require "ecore"
require "ecore_x"
require "ecore_evas"
require "edje"

$s = []

$s << "Metallica - Battery"
$s << "Amon Amarth - ...And Soon The World Will Cease To Be"
$s << "Edguy - Jerusalem"

def next_song
	r = $s.shift
	$s << r

	r
end

def main
	ee = Ecore::Evas::SoftwareX11.new
	ee.title = "ruby-evas/edje/ecore \o/"
	ee.borderless = true
	ee.shaped = true

	ee.on_pre_render { Edje::thaw }
	ee.on_post_render { Edje::freeze }

	edje = Edje::Edje.new(ee.evas)
	edje.load("/home/tilman/.e/apps/euphoria/themes/multipass.eet", "euphoria")
	edje.name = "main object"

	edje.on_signal("QUIT") do |signal, src|
		Ecore.main_loop_quit
	end

	edje.on_signal("PLAY_NEXT") do
		msg = Edje::StringMessage.new(next_song)
		edje.send_message(msg)
	end

	edje.on_signal("PRINT") do |sig, src|
		puts src
	end

	w, h = edje.get_size_max
	ee.set_size_max(w, h)

	w, h = edje.get_size_min
	ee.set_size_min(w, h)

	edje.resize(w, h)
	ee.resize(w, h)

	edje.show
	ee.show

	Ecore::main_loop_begin
end

main
