require "evas"
require "ecore"
require "ecore_x"
require "ecore_evas"
require "esmart"
require "esmart_draggies"
require "esmart_trans_x11"

def on_ee_resize_move(ee)
	x, y, w, h = ee.geometry

	ee.evas.find_object("dragger").resize(w, h)
	ee.evas.find_object("shade").resize(w, h)
	ee.evas.find_object("trans").resize(w, h)
	ee.evas.find_object("trans").freshen(x, y, w, h)
end

def main
	ee = Ecore::Evas::SoftwareX11::new
	ee.title = "ruby-evas/ecore/esmart \o/"
	ee.borderless = true
	ee.shaped = true

	ee.on_resize { on_ee_resize_move(ee) }
	ee.on_move { on_ee_resize_move(ee) }

	dragger = Esmart::Draggies::new(ee)
	dragger.name = "dragger"
	dragger.button = 1
	dragger.show

	trans = Esmart::TransX11::new(ee.evas)
	trans.name = "trans"
	trans.layer = -2
	trans.window = ee.window
	trans.show

	shade = Evas::Rectangle::new(ee.evas)
	shade.name = "shade"
	shade.layer = -1
	shade.set_color(0, 0, 0, 32)
	shade.show

	ee.resize(200, 200)
	ee.show

	Ecore::main_loop_begin
end

main
