require "ecore_x"
require "ecore_evas"

class Bg < Evas::EvasObject
	@@smart = nil
	@bg = nil

	def Bg.new(evas)
		@@smart ||= Evas::Smart.new("dragger")
		return @@smart.new_object(Bg, evas)
	end

	def initialize(evas)
		super
		@bg = Evas::Rectangle.new(evas)
	end

private
	def on_show
		@bg.show
	end

	def on_hide
		@bg.hide
	end

	def on_layer_set(layer)
		@bg.layer = layer
	end

	def on_move(x, y)
		@bg.move(x, y)
	end

	def on_resize(w, h)
		@bg.resize(w, h)
	end

	def on_color_set(r, g, b, a)
		@bg.set_color(r, g, b, a)
	end
end

ee = Ecore::Evas::SoftwareX11.new

ee.title = "EcoreEvas with Ruby, baby :)"
ee.resize(400, 200);
ee.show

d = Bg.new(ee.evas)
d.set_color(255, 0, 0, 128)
d.move(0, 0)
d.resize(400, 200)
d.layer = -1
d.show

Ecore::main_loop_begin
